#include "Split.h"

Split::Split(char *p, const char *gap) {
    using namespace std;

    for(argument_count = 0; argument_count < SPLIT_ARRAY_SIZE; argument_count += 1) {
        a[argument_count] = strtok(p, gap);
        if (a[argument_count] == NULL) {
            break;
        } else {
            s[argument_count] = new string(a[argument_count]);
        }

        p = NULL;
    }

}

Split::Split(char *p, const char *gap, bool exe) {
    using namespace std;

    char *place = p;
    const char EXECUTABLE[5] =".exe";
    if(exe) {
        p = strstr(place, EXECUTABLE);
        if(p == NULL) {
            p = place;
        }

    }

    for(argument_count = 0; argument_count < SPLIT_ARRAY_SIZE; argument_count += 1) {
        a[argument_count] = strtok(p, gap);
        if (a[argument_count] == NULL) {
            break;
        } else {
            s[argument_count] = new string(a[argument_count]);
        }

        p = NULL;
    }

}

Split::Split(char *p, const char *gap, int required) {
    using namespace std;

    for(argument_count = 0; argument_count < SPLIT_ARRAY_SIZE; argument_count += 1) {
        a[argument_count] = strtok(p, gap);
        if (a[argument_count] == NULL) {
            break;
        } else {
            s[argument_count] = new string(a[argument_count]);
        }

        p = NULL;
    }

    for( ; argument_count < required; argument_count += 1) {
        s[argument_count] = new string("");
    }

}

Split::Split(std::string & commandLine, const char *gap, int required) {
    using namespace std;
                         
    int buffer_size = commandLine.length();
    char *p = new char[ buffer_size + 1 ];
    strcpy(p, commandLine.c_str() );

    for(argument_count = 0; argument_count < SPLIT_ARRAY_SIZE; argument_count += 1) {
        a[argument_count] = strtok(p, gap);
        if (a[argument_count] == NULL) {
            break;
        } else {
            s[argument_count] = new string(a[argument_count]);
        }

        p = NULL;
    }

    for( ; argument_count < required; argument_count += 1) {
        s[argument_count] = new string("");
    }

    delete p;
}

Split::~Split() {
    for(int i = 0; i < argument_count; ++i) {
        delete s[i];
    }

}

